/*-------------------------------------------------------------------
[SCRIPT]   Interroger SystemHealth
[DATABASE] 
[DESCRIPTION] Journes SQL Server 2013
[MAJ PAR] DATAFLY - Arian Papillon
[DATEMAJ]  01/12/2013
-------------------------------------------------------------------*/

-- Lock waits > 30 s
DECLARE @x XML = 
(select CAST(xet.target_data as xml) from sys.dm_xe_session_targets xet 
join sys.dm_xe_sessions xe 
on (xe.address = xet.event_session_address) 
where xe.name = 'system_health' AND xet.target_name='ring_buffer')
SELECT t.e.value('@name', 'varchar(50)') AS EventName
    ,t.e.value('@timestamp', 'datetime') AS DateAndTime
    ,t.e.value ('(data[@name="wait_type"]/text)[1]', 'VARCHAR(100)') AS [Wait Type]
    ,CONVERT (FLOAT, t.e.value ('(data[@name="duration"]/value)[1]', 'BIGINT')) / 1000 AS [Duration (s)]
	,t.e.value('(action[@name="session_id"]/value)[1]', 'int') AS [spid]
    ,t.e.value('(action[@name="sql_text"]/value)[1]', 'varchar(max)') AS sql_text
FROM @x.nodes('//RingBufferTarget/event') AS t(e)
WHERE t.e.value('@name', 'varchar(50)') = 'wait_info'    
AND t.e.value ('(data[@name="wait_type"]/text)[1]', 'VARCHAR(100)') like 'LCK%'
GO

-- Deadlock Graph
DECLARE @x XML = 
(select CAST(xet.target_data as xml) from sys.dm_xe_session_targets xet 
join sys.dm_xe_sessions xe 
on (xe.address = xet.event_session_address) 
where xe.name = 'system_health' AND xet.target_name='ring_buffer')
SELECT t.e.query('(data/value/deadlock)[1]') AS DeadLockGraph
FROM @x.nodes('//RingBufferTarget/event') AS t(e)
WHERE t.e.value('@name','varchar(4000)') = 'xml_deadlock_report'