/*-------------------------------------------------------------------
[SCRIPT]   Interroger SystemHealth
[DATABASE] 
[DESCRIPTION] Journes SQL Server 2013
[MAJ PAR] DATAFLY - Arian Papillon
[DATEMAJ]  01/12/2013
-------------------------------------------------------------------*/

-- Configuration du threshold  5 secondes
	EXECUTE sp_configure 'show advanced options', 1
    GO
	RECONFIGURE
    GO
	EXECUTE sp_configure 'blocked process threshold', 5
    GO
	RECONFIGURE
    GO
	EXECUTE sp_configure 'show advanced options', 0
    GO
	RECONFIGURE
    GO

-- Session XEvent
	CREATE EVENT SESSION LocksReporting ON SERVER ADD EVENT sqlserver. blocked_process_report ADD TARGET package0.
	  ring_buffer ( SET MAX_MEMORY=2048 ) WITH ( MAX_DISPATCH_LATENCY = 5 SECONDS )
    GO
	ALTER EVENT SESSION LocksReporting
	ON SERVER
	STATE=START
    GO


	-- Requte de lecture des rsultats
	SELECT	n.value('(event/@name)[1]', 'varchar(50)') AS event_name
		   ,n.value('(event/@package)[1]', 'varchar(50)') AS package_name
		   ,DATEADD(hh, DATEDIFF(hh, GETUTCDATE(), CURRENT_TIMESTAMP), n.value('(event/@timestamp)[1]', 'datetime2')) AS [timestamp]
		   ,ISNULL(n.value('(event/data[@name="database_id"]/value)[1]', 'int'),
				   n.value('(event/action[@name="database_id"]/value)[1]', 'int')) AS [database_id]
		   ,n.value('(event/data[@name="database_name"]/value)[1]', 'nvarchar(128)') AS [database_name]
		   ,CAST(n.value('(event/data[@name="duration"]/value)[1]', 'bigint') / 1000000.0 AS DECIMAL(6, 2)) AS [duration_seconds]
		   ,n.value('(event/data[@name="lock_mode"]/text)[1]', 'nvarchar(10)') AS [file_handle]
		   ,n.value('(event/data[@name="transaction_id"]/value)[1]', 'bigint') AS [transaction_id]
		   ,n.value('(event/data[@name="resource_owner_type"]/text)[1]', 'nvarchar(10)') AS [resource_owner_type]
		   ,n.query('(event/data[@name="blocked_process"]/value/blocked-process-report)[1]') AS [blocked_process_report]
	FROM	( SELECT td.query('.') AS n
			  FROM	 ( SELECT CAST(target_data AS XML) AS target_data
					   FROM	  sys.dm_xe_sessions AS s
							  JOIN sys.dm_xe_session_targets AS t ON s.address = t.event_session_address
					   WHERE  s.name = 'LocksReporting'
							  AND t.target_name = 'ring_buffer'
					 ) AS sub
					 CROSS APPLY target_data.nodes('RingBufferTarget/event') AS q ( td )
			) AS TAB

-- Mise en forme avec procdure sp_blocked_process_report_viewer
EXEC sp_blocked_process_report_viewer 
	@Trace = 'LocksReporting'
   ,@Type = 'XEVENT_RINGBUFFER'
  